package com.thebrokenrail.sorcerycraft.mixin;

import com.thebrokenrail.sorcerycraft.gui.CastingTableScreenHandler;
import com.thebrokenrail.sorcerycraft.spell.util.SpellHelper;
import com.thebrokenrail.sorcerycraft.spell.util.SpellPlayerEntity;
import net.minecraft.container.Container;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.util.Identifier;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.HashMap;
import java.util.Map;

@SuppressWarnings("unused")
@Mixin(PlayerEntity.class)
public class MixinPlayerEntity implements SpellPlayerEntity {
    @Shadow
    public Container container;
    @Unique
    private Map<Identifier, Integer> discoveredSpells = new HashMap<>();

    @Inject(at = @At("HEAD"), method = "readCustomDataFromTag")
    public void readCustomDataFromTag(CompoundTag tag, CallbackInfo info) {
        discoveredSpells = SpellHelper.getSpells(tag);
    }

    @Inject(at = @At("HEAD"), method = "writeCustomDataToTag")
    public void writeCustomDataToTag(CompoundTag tag, CallbackInfo info) {
        tag.put(SpellHelper.SPELL_TAG, SpellHelper.createSpellsTag(discoveredSpells));
    }

    @Override
    public void setDiscoveredSpells(Map<Identifier, Integer> spells) {
        discoveredSpells = spells;
        if (container instanceof CastingTableScreenHandler) {
            //noinspection ConstantConditions
            ((CastingTableScreenHandler) container).setSpells((PlayerEntity) (Object) this);
        }
    }

    @Override
    public Map<Identifier, Integer> getDiscoveredSpells() {
        return discoveredSpells;
    }
}
